	--[[  ----------------- from wowwiki.com -------------------
	DEFAULT_CHAT_FRAME:AddMessage("")
	DisableAddOn(index or "AddOnName")   - Disable the specified AddOn for subsequent sessions. 
	DisableAllAddOns()   - Disable all AddOns for subsequent sessions. 
	EnableAddOn(index or "AddOnName")   - Enable the specified AddOn for subsequent sessions. 
	EnableAllAddOns()   - Enable all AddOns for subsequent sessions. 
	GetAddOnDependencies(index or "AddOnName")   - Get dependency list for an AddOn. 
	GetAddOnInfo(index or "AddOnName")   - Get information about an AddOn. 
	GetAddOnMetadata(index or "name", "variable")   - Retrieve metadata from addon's TOC file. 
	GetNumAddOns()   - Get the number of user supplied AddOns. 
	IsAddOnLoaded(index or "AddOnName")   - Returns true if the specified AddOn is loaded. 
	IsAddOnLoadOnDemand(index or "AddOnName")   - TMA whether an AddOn is load-on-demand. 
	LoadAddOn(index or "AddOnName")   - Request loading of a Load-On-Demand AddOn. 
	ResetDisabledAddOns() 
	
	name, title, notes, enabled, loadable, reason, security = GetAddOnInfo(index or "name")
	]]
	
-- the structure looks like this
--
--  TMAprofiles[x] = (profilename, {addonname = BOOLEAN}

--TMAdebug = true


function TMA_onload() 

    TMAframe = CreateFrame("Frame",TMAframe,UIParent)
    TMAframe:SetScript("OnEvent",TMA_onevent)

    TMAframe:RegisterEvent('VARIABLES_LOADED')

	-- create our slash commands
	SLASH_TMA1 = "/TMA";
	SLASH_TMA2 = "/tma";
	SLASH_TMA3 = "/TooManyAddons";
	SLASH_TMA4 = "/toomanyaddons";
	SlashCmdList["TMA"] = TMA; 
	
	TMAcreateinterface()
	TMAcreateoptionframe()
	
	if(GetNumAddOns() > 100) then
		DEFAULT_CHAT_FRAME:AddMessage(GetNumAddOns().." addons found.  You have TooManyAddons! ('/TMA help' for more info)")
	else
		DEFAULT_CHAT_FRAME:AddMessage("Only "..GetNumAddOns().." addons found.  Get some more! ('/TMA help' for more info)")
	end
 	--end loading
 	

 	
end 



--sort menu initialization
function TMAsortMenu_Initialise(self,level)
   local level = level or 1
   if (level == 1) then
      local info = UIDropDownMenu_CreateInfo();
      local key, value
      for i = 1,#TMAsortmethods do
            info.text = TMAsortmethods[i].caption
    	    info.value = i
    	    info.hasArrow = false
    	    info.notCheckable = false
    	    info.owner = self:GetParent()
    	    info.func =  TMAsortMenuItem_OnClick
    	    if(i == TMAsortmethodnum) then
    	        info.checked = true
    	    else
                info.checked = false
    	    end
    	    UIDropDownMenu_AddButton(info,level)
      end
    end
end

function TMAsortMenuItem_OnClick()
   --if they clicked it again, change desc/asc
   if(TMAsortmethodnum == this.value) then
        TMAsortdesc = not TMAsortdesc
        TMAprint("SWapping.  NOW is: "..tostring(TMAsortdesc))
   else
        TMAsortmethodnum = this.value
   end
   TMAupdate()
end





function TMAdropDownMenu_Initialise(self,level)
   local level = level or 1 --drop down menues can have sub menues. The value of level determines the drop down sub menu tier 
   --TMAprint("level = ")
   --TMAprint(level)
 
   if(level == 1) then
      local info = UIDropDownMenu_CreateInfo(); 
      local key, value
      if(TMAsettings) then
    	 for key,value in pairs(TMAsettings.servers) do
    	    info.text = key
    	    info.value = key
    	    info.hasArrow = true
    	    info.notCheckable = true
    	    info.owner = self:GetParent()
    	    UIDropDownMenu_AddButton(info,level)
    	 end
      else
	    info.text = "No Data"
	    info.value = nil
	    info.hasArrow = false
	    info.owner = self:GetParent()
	    UIDropDownMenu_AddButton(info,level)
      end
   elseif (level == 2) then
      local info = UIDropDownMenu_CreateInfo();
      local key, value, server, parent
      server=UIDROPDOWNMENU_MENU_VALUE
      if(TMAsettings and TMAsettings.servers and TMAsettings.servers[server]) then
    	 for key,value in pairs(TMAsettings.servers[server]) do
    	    info.text = key
    	    info.value = {server,key}
    	    info.hasArrow = false
    	    info.server = server
    	    info.func =  TMAdropDownMenuItem_OnClick
    	    UIDropDownMenu_AddButton(info,level)
    	 end
      end

   end
end

function TMAdropDownMenuItem_OnClick()
   -- this is where the actual importing takes place
   local playerName = UnitName("player");
   local serverName = GetCVar("realmName");
   local index,temptable
   local server = this.value[1]
   local name = this.value[2]

   if (not (server and name)) then
        TMAprint("Server or name not found")
        return false
   end
   for index,temptable in pairs(TMAsettings.servers[server][name]) do
       --sometimes theres a garbage table floating around for whatever reason
      if type(temptable) == "table" then
    	 if temptable["profilename"] then
    	    if  (server == serverName and name == playerName) then
    	       -- it creates an infinite loop if you keep adding yourseelf
    	    else
    	       local tablecopy = {}
    	       TMA_tcopy(tablecopy,temptable) -- this is an unfortunate and slow necessity because table.insert doesnt copy tables.
    	       table.insert(TMAprofiles,tablecopy)  -- because otherwise merely the reference to it is inserted, meaning changing a profile changes the original
    	    end
    	 end
      end
   end

   TMAupdate()
end 




------------------------ event handler --------------------------
function TMA_onevent()
    TMAprint("|c00ffbb00event triggered")
    TMAprint(event)
    TMAprint(arg1)
	if (event == 'VARIABLES_LOADED') then
	   TMAinitialize()
	end
end
-----------------------------------------------------------------

function TMAinitialize()
-- this is where we set up and retrieve global variables, stored in TMAsettings
   if not (TMAsettings) then
      TMAsettings = {}
   end

   if not TMAsettings.servers then
      TMAsettings.servers = {}
   end
   local playerName = UnitName("player");
   local serverName = GetCVar("realmName");
   -- Do nothing if player name is not available
   if (playerName == nil or playerName == UNKNOWNOBJECT or playerName == UKNOWNBEING) then
      return;
   end
   
   if not TMAsettings.servers[serverName] then
      TMAsettings.servers[serverName] = {}
   end
   
   TMAprint("Intializing TMAsettings")


   TMAselectedprofilenums = {}
   
   -- if nothing existed, create it all from scratch (the defauts)
   if not TMAsettings.servers[serverName][playerName] then
		 TMAsettings.servers[serverName][playerName] = {}
		
		 if not TMAprofiles then
			 TMAprofiles = {}
			 -- create one default profile that only is needed the very first time someone uses TMA
			 TMAprofiles[1] = {}
			 TMAselectedprofilenums[1] = 1
			 TMAprofiles[TMAselectedprofilenums[1]].profilename = "Default"
			 for i=1, GetNumAddOns() do
				name,title,_, enabled, _, _, _ = GetAddOnInfo(i)
				--local ourbutton = getglobal(TMA_ADDON_LIST_NAME.."button"..i)
				TMAprofiles[TMAselectedprofilenums[1]][name] = enabled  --this syntax does work
			 end
		 end
		 if not TMAprofiles.TMAselectedprofilenums then
			  TMAprofiles.TMAselectedprofilenums = {}
			  TMAprofiles.TMAselectedprofilenums[1] = 1
		 end
		 --save it into the master table
		 TMAsettings.servers[serverName][playerName] = TMAprofiles
   else
		  --retrieve the selected profile, if any
		  TMAprofiles = TMAsettings.servers[serverName][playerName]
		  TMAselectedprofilenums[1] = 1
		  if(TMAprofiles.TMAselectedprofilenums) then
			 --TMAprint("Copying TMAselectedprofiles")
			 TMA_tcopy(TMAselectedprofilenums, TMAprofiles.TMAselectedprofilenums)
		  end
   end

-- set the position of our frame
   if TMAprofileframe then
      local point, relativeTo, relativePoint, xOfs, yOfs
      if TMAsettings.point then
    	 point = TMAsettings.point
    	 relativeTo = TMAsettings.relativeTo
    	 relativePoint = TMAsettings.relativePoint
    	 xOfs =  TMAsettings.xOfs
    	 yOfs =  TMAsettings.yOfs
    	 TMAprofileframe:SetPoint(point,relativeTo,relativePoint,xOfs,yOfs)
      end
   end


 --not sure when this should be called.  put here for now.
   createalwaysprofile()

 -- setup grouping table
	TMAgrouping = true
    TMAsetupgroups()
	
  	TMAsortdesc = false --sort descending
    TMAcreatesortingmethods()
    --TMAprint(TMAsortmethods)

    --create master list of addons storing date first seen
    if not (TMAsettings.dates) then
        TMAsettings.dates = {}
    end
    for i = 1,GetNumAddOns() do
       name,title,_, _, _, _, _ = GetAddOnInfo(i)
       if not (TMAsettings.dates[name]) then
           TMAsettings.dates[name] = date("%y%m%d")
       end
    end
    if(TMAprofiles.sortmethodnum) then
       TMAsortmethodnum = TMAprofiles.sortmethodnum
    end

    --set dropdown menu values
	UIDropDownMenu_Initialize(TMAdropDownMenu,TMAdropDownMenu_Initialise);
	UIDropDownMenu_Initialize(TMAsortMenu,TMAsortMenu_Initialise);

	
	-------options-----
		--hide or show the game menu button (when you press esc)
	if (TMAsettings.hidegamemenubutton) then
		TMAhidegamemenubutton = TMAsettings.hidegamemenubutton
	else
		TMAhidegamemenubutton = false
	end
	TMAoption1:SetChecked(TMAhidegamemenubutton)
	
	if (TMAsettings.grouping) then
		TMAgrouping = TMAsettings.grouping
	else
		TMAgrouping = false
	end
	TMAoption2:SetChecked(TMAgrouping)
	
	if (TMAsettings.hidetooltips) then
		TMAhidetooltips = TMAsettings.hidetooltips
		TMAprint("TMAsettings.hidetooltips |c0033ff00 found: "..tostring(TMAsettings.hidetooltips))
	else
		TMAprint("TMAsettings.hidetooltips |c00ff0000 NOT found.  that means its false, dummy")
		TMAhidetooltips = false
	end
	TMAoption3:SetChecked(TMAhidetooltips)
	
	
	

	TMAlastloadedprofilenums = TMAprofiles.TMAlastloadedprofilenums
	
	TMAupdate()  --this is just needed here for the game menu button X_X in case they go streaight to the game menu before opening up the TMA interface
		
end --end initialize

function TMAsetupgroups()
local  groupname,name,title,ourstruct,prefix
    TMAprint("|c00ffff00Creating TMA Groups.")
    TMAgroups = {}
	local tempgroup = {}
	
	--allow them to start with everything showing or hidden
	if TMAsettings.TMAcollapseall then
		TMAcollapseall = TMAsettings.TMAcollapseall
	else
		TMAcollapseall = true
	end
 
	--TMAADDONSTOMAKEAGROUP
	
	
    for i=1,GetNumAddOns() do
		--loop through everything once and count each prefix
		name,title,_, _, _, _, _ = GetAddOnInfo(i)
		prefix = string.sub(name,1,TMACHARSTOCOMP)
		if not (tempgroup[prefix]) then
			tempgroup[prefix] = 0
		end
		tempgroup[prefix] = tempgroup[prefix] + 1
	end
	
	for i=1,GetNumAddOns() do
		name,title,_, _, _, _, _ = GetAddOnInfo(i)
		prefix = string.sub(name,1,TMACHARSTOCOMP)
		if (tempgroup[prefix] >= TMAADDONSTOMAKEAGROUP) then
			if (not TMAgroups[prefix])  then
				TMAgroups[prefix] = {}
				TMAgroups[prefix].collapsed = TMAcollapseall  --the default
				TMAgroups[prefix].header = name
				TMAgroups[prefix].kids = {}
			end
			ourstruct = {}
			ourstruct.name = name
			ourstruct.addonnumber = i
			table.insert(TMAgroups[prefix].kids,ourstruct)
		end
	end
	
end


function TMAcreatesortingmethods()
    --creating sorting table methods
    TMAsortmethods = {}

    --alphabetical
    ourstruct = {}
    ourstruct.caption = "Alphabetical"
    ourstruct.func = function(a,b)
        if not (a and b) then
           return false
        end
        if(TMAisgrouped(b.name) and not TMAisheader(b.name)) then
           return false
        end
        a=TMAsanitize(a.title)
        b=TMAsanitize(b.title)
        if (TMAsortdesc) then
            return a > b
        else
            return a < b
        end
    end
    table.insert(TMAsortmethods,ourstruct)

    --author
    ourstruct = {}
    ourstruct.caption = "Author"
    ourstruct.func = function(a,b)
       if not (a and b) then
           return true
        end
       local Aauthor = GetAddOnMetadata(a.name, "Author") or ""
       local Bauthor = GetAddOnMetadata(b.name, "Author") or ""
       Aauthor = TMAsanitize(Aauthor)
       Bauthor = TMAsanitize(Bauthor)
       if (TMAsortdesc) then
           return Aauthor > Bauthor
       else
           return Aauthor < Bauthor
       end
    end
    table.insert(TMAsortmethods,ourstruct)

    --default
    ourstruct = {}
    ourstruct.caption = "Bliz Default"
    ourstruct.func = function(a,b)
        return a.addonnumber < b.addonnumber
    end
    table.insert(TMAsortmethods,ourstruct)

    --checked
    ourstruct = {}
    ourstruct.caption = "Checked"
    ourstruct.func = function(a,b)
        if not (a and b) then
            TMAprint("IM NOT HAPPY")
            return false
        end
        local achecked,bchecked = false
        for i = 1,#TMAselectedprofilenums do
            if (TMAprofiles[TMAselectedprofilenums[i]][a.name]) then
               achecked = true
            end
            if (TMAprofiles[TMAselectedprofilenums[i]][b.name]) then
               bchecked = true
            end
        end
        if(TMAsortdesc) then
            return (not achecked and bchecked)
        else
            return (achecked and not bchecked)
        end
    end
    table.insert(TMAsortmethods,ourstruct)

    --date?
    ourstruct = {}
    ourstruct.caption = "Date Acquired"
    ourstruct.func = function(a,b)
        if (TMAsortdesc) then
           return TMAsettings.dates[a.name] < TMAsettings.dates[b.name]
        else
           return TMAsettings.dates[a.name] > TMAsettings.dates[b.name]
        end

        --i'll have to capture A date on every addon
    end
    table.insert(TMAsortmethods,ourstruct)

    --enabled
    ourstruct = {}
    ourstruct.caption = "Enabled"
    ourstruct.func = function(a,b)
       local aenabled,benabled
       local name, title, notes, aenabled, loadable, reason, security = GetAddOnInfo(a.name)
       local name, title, notes, benabled, loadable, reason, security = GetAddOnInfo(b.name)
       if(TMAsortdesc) then
            return tostring(aenabled) > tostring(benabled)
       else
            return tostring(aenabled) < tostring(benabled)
       end
    end
    table.insert(TMAsortmethods,ourstruct)



--The comparison function must return a boolean value specifying whether the first argument should be before the second argument in the sequence. The default behaviour is for the < comparison to be mad
--it can never be 'return true' else well get an infinite loop.  return false, ok.  true, no.
end

function TMAsanitize(str)
    str = string.lower(str)
    str = string.gsub(str,'|c........',"")
    str = string.gsub(str,'|r',"")
    str = string.gsub(str,'[^a-z]',"")
    return str
end



-- when someone clicks the button or types /tma this is called
function TMA(input)
   if(input) then
      if(input == "help") then
        local helpspam = {}
    	 helpspam[1] = "*** Welcome to TooManyAddons!  Features that aren't instantly obvious:\n*There is a new 'addon' button in the game menu, that opens up the TooManyAddons interface.\n* '/TMA' will also open up the interface."
    	 helpspam[2] = "\n* '/TMA someProfile' will instantly load that profile.\n  Handy for you macrophiles.  Spelling is  exact."
    	 helpspam[3] = "\n* The interface can be moved by dragging the 'profile' frame.\n  You have to click on the edge of the frame or a clear spot."
    	 helpspam[4] = "\n* A profile called 'Default' is created at the very first use of TooManyAddons, for your convenience.  Feel free to delete it."
    	 helpspam[5] = "\n* A profile called 'Always Load These Addons' will always exist.  Anything checked in this profile will always load, no matter what.  The checked items will appear grey or shiny in other profiles.  By default, TooManyAddons will be checked in this profile."
         helpspam[6] = "\n* Tooltips show you the description of the addon.\n* Clicking an addon will automatically click all of its dependencies."
         helpspam[7] = "\n* Addons with the same first four letters are grouped up.\n Clicking the head of a group will act as if you clicked everything in the group."
         helpspam[8] = "\n* Hold down the Ctrl or Shift key when selecting profiles to load addons from multiple profiles."
		 helpspam[9] = "\n* The most recently loaded profile(s) will appear green."
		 helpspam[10] = "\n* '/TMA hidebutton' will remove the 'addon' button in the game menu."
     
         for i = 1,#helpspam do
    	     DEFAULT_CHAT_FRAME:AddMessage(helpspam[i])
         end

      elseif (input == "test") then
         
         TMAprint("Addon display list")
         TMAprint(TMAaddondisplaylist)
         --TMAprint("TMAgroups")
         --TMAprint(TMAgroups)
        
        TMAprint("Creating a button")
        name = TMA_ADDON_LIST_NAME
        local ourframe = getglobal(name.."frame")
	    local ournamebutton = CreateFrame("Button",nil,UIParent)
		ournamebutton:SetHeight(300)
		ournamebutton:SetWidth(300)
		ournamebutton:SetPoint("RIGHT")
		ournamebutton:SetNormalFontObject(GameFontNormal)
		ournamebutton:SetHighlightTexture("Interface\\QuestFrame\\UI-QuestLogTitleHighlight")
		ournamebutton:SetNormalTexture("Interface\\Minimap\\UI-Minimap-ZoomInButton-Up")
		ournamebutton:SetText("Button 1")
		
		TMAtexturemiddle = ournamebutton:CreateTexture()
        TMAtexturemiddle:SetWidth(300)
        TMAtexturemiddle:SetHeight(300)
        TMAtexturemiddle:SetAllPoints()
        TMAtexturemiddle:SetTexture("Interface\\PaperDollInfoFrame\\UI-Character-ScrollBar")
	  elseif (input == "debug") then
		TMAdebug = not TMAdebug
		DEFAULT_CHAT_FRAME:AddMessage("debug: "..tostring(TMAdebug))
	  elseif (input == "hidebutton") then
		TMAhidegamemenubutton = not TMAhidegamemenubutton
		DEFAULT_CHAT_FRAME:AddMessage("TMA Game Menu Button Hidden?:".."|c00ff00ff"..tostring(TMAhidegamemenubutton).."|r")
	  elseif (input == "grouping") then	
		TMAgrouping = not TMAgrouping
		DEFAULT_CHAT_FRAME:AddMessage("Grouping on?  :".."|c00ff00ff"..tostring(TMAgrouping).."|r")
		if (TMAgrouping) then
			TMAsetupgroups()
		else
			TMAprint("Setting TMAGROUPS to |c00ff0000 Nil")
			TMAgroups = nil
		end
	elseif (input == "option" or input == "options") then
	    InterfaceOptionsFrame_OpenToCategory("TooManyAddons");
	  
	  else  -- this is for macrophiles who want to go '/tma raid', thus loading a profile with no mouse clicks
	       --DEFAULT_CHAT_FRAME:AddMessage(input)
			if(input ~= "") then
	           TMAloadprofile(input)
			else  --input was ""
				-- open the interface.
			   local pframe = getglobal(TMA_PROFILE_LIST_NAME.."frame")
			   local aframe = getglobal(TMA_ADDON_LIST_NAME.."frame")
			   if(pframe and aframe) then
				  if(pframe:IsVisible())then
					pframe:Hide()
					aframe:Hide()
				  else
					pframe:Show()
					aframe:Show()
				  end
			   end
			   ourscrollbar_Update(TMA_PROFILE_LIST_NAME)
			end
      end
	  
	else --no input  --called when you push the addon button in the game menu

		-- open the interface.
	   local pframe = getglobal(TMA_PROFILE_LIST_NAME.."frame")
	   local aframe = getglobal(TMA_ADDON_LIST_NAME.."frame")
	   if(pframe and aframe) then
		  if(pframe:IsVisible())then
			pframe:Hide()
			aframe:Hide()
		  else
			pframe:Show()
			aframe:Show()
		  end
	   end
	   ourscrollbar_Update(TMA_PROFILE_LIST_NAME)

   end

   TMAupdate()	

end





------------------------------------- UPDATE ----------------------------------
--all graphical stuff happens here.
function TMAupdate()
    TMAprint("|cc00aaffffTMA update called")
	--TMAprint("TMAselectedprofilenums")
	--TMAprint(TMAselectedprofilenums)

    local name,title,notes,ourstruct,currentbutton,currentcheckbutton,ourtitle,numtodisplay,collapsebutton,ourstruct,addonname,addontitle,addonnumber
    local issecondary
--GET the objects we will be working with
    local TMAaddonframe = getglobal(TMA_ADDON_LIST_NAME.."frame")
    local TMAprofileframe = getglobal(TMA_PROFILE_LIST_NAME.."frame")
    if not(TMAaddonframe and TMAprofileframe) then return false end;

    --we have no selected addons
    if not (TMAselectedprofilenums[1]) then
        TMAselectedprofilenums[1] = #TMAprofiles
    end
    if (TMAselectedprofilenums[1] > #TMAprofiles) then
		TMAselectedprofilenums[1] = #TMAprofiles
	end
    if(#TMAprofiles == 0) then
        TMAselectedprofilenums={}
    end

    if(TMAselectedprofilenums[1]) then
        if (not TMAaddonframe:IsVisible() and TMAprofileframe:IsVisible()) then
            TMAaddonframe:Show()
        end
        if(TMAselectedprofilenums[1] > #TMAprofiles) then
            TMAselectedprofilenums[1] = #TMAprofiles
        end

        TMAcreatedisplaylist()  -- this is where the real logic takes place.  most bugs will be here.

			--TMAprint("|c00eeff00Addondisplaylist:")
			--TMAprint(TMAaddondisplaylist[1])

    	local ourscrollbar = getglobal(TMA_ADDON_LIST_NAME.."scrollbarScrollBar")
        --set scroll bar limits
        local rtcf = TMArowsthatcanfit(TMA_ADDON_LIST_NAME)
        ourscrollbar:SetMinMaxValues(0,math.max(0,#TMAaddondisplaylist-rtcf))
        --get the scroll bar value
    	offset = ourscrollbar:GetValue()

        local currentcollapsebutton,currentcheckbutton,currentbutton, value, ratio
        ratio = {-.2,1,-.1,1.1}
        --create that many buttons and check buttons
        for i=1,rtcf do
            --check if the button exists already  --checkbutton first, then regular button
            currentcheckbutton = getglobal(TMA_ADDON_LIST_NAME.."checkbutton"..i)
            if not currentcheckbutton then
                TMAcreateaddonbutton(i)
            end
            currentcheckbutton = getglobal(TMA_ADDON_LIST_NAME.."checkbutton"..i)
            currentbutton = getglobal(TMA_ADDON_LIST_NAME.."button"..i)
            currentcollapsebutton = getglobal("TMAcollapsebutton"..i)
			
            numtodisplay = offset + i
			--TMAprint("showing addon #"..numtodisplay)
			if(TMAaddondisplaylist[numtodisplay]) then
				addontitle = TMAaddondisplaylist[numtodisplay].title
				addonname = TMAaddondisplaylist[numtodisplay].name
				addonnumber = TMAaddondisplaylist[numtodisplay].addonnumber
				
				--TMAprint("|c00ffff00  WHAT THE HELL?? numtodisplay ")
				--TMAprint(numtodisplay)
				--TMAprint(TMAaddondisplaylist[numtodisplay])
				
			else
				
				--TMAprint("|c00ffff00  WHAT THE HELL?? numtodisplay ")
				--TMAprint(numtodisplay)
				return false
			end
			
	
			--TMAprint("showing addon #"..numtodisplay.." name of: "..addontitle)
			
            --set the +/- button
            if(TMAisheader(addonname)) then
                --TMAprint(addonname.. "  identified as header")
                currentcollapsebutton:Show()
                --update +/-
                local groupname = string.sub(addonname,1,TMACHARSTOCOMP)
                currentcollapsebutton.groupname = groupname

            	if (TMAgroups[groupname].collapsed) then
        		   --currentcollapsebutton:SetText("+")
        		   currentcollapsebutton:SetNormalTexture("Interface\\Minimap\\UI-Minimap-ZoomInButton-Up")
				  currentcollapsebutton:SetHighlightTexture("Interface\\Minimap\\UI-Minimap-ZoomInButton-Up")
				  currentcollapsebutton:SetPushedTexture("Interface\\Minimap\\UI-Minimap-ZoomInButton-Down")
        		else
        		   --currentcollapsebutton:SetText("-")
        		   currentcollapsebutton:SetNormalTexture("Interface\\Minimap\\UI-Minimap-ZoomOutButton-Up")
				   currentcollapsebutton:SetHighlightTexture("Interface\\Minimap\\UI-Minimap-ZoomOutButton-Up")
				   currentcollapsebutton:SetPushedTexture("Interface\\Minimap\\UI-Minimap-ZoomOutButton-Down")
        		end
            else
                currentcollapsebutton.groupname = nil
                currentcollapsebutton:Hide()
            end

            --strink the text on groups??  no, make it green.  No, indent it!  No, different font!
            if(TMAisgrouped(addonname) and (not TMAisheader(addonname))) then
                currentbutton:SetNormalFontObject(GameFontNormalSmall)
                --shrink the buttons
                currentcheckbutton:GetNormalTexture():SetTexCoord(ratio[1],ratio[2],ratio[3],ratio[4])
                currentcheckbutton:GetPushedTexture():SetTexCoord(ratio[1],ratio[2],ratio[3],ratio[4])
                currentcheckbutton:GetCheckedTexture():SetTexCoord(ratio[1],ratio[2],ratio[3],ratio[4])
                currentcheckbutton:GetHighlightTexture():SetTexCoord(ratio[1],ratio[2],ratio[3],ratio[4])
                currentcheckbutton:GetDisabledTexture():SetTexCoord(ratio[1],ratio[2],ratio[3],ratio[4])
            else
                currentbutton:SetNormalFontObject(GameFontNormal)
                currentcheckbutton:GetNormalTexture():SetTexCoord(0,1,0,1)
                currentcheckbutton:GetPushedTexture():SetTexCoord(0,1,0,1)
                currentcheckbutton:GetCheckedTexture():SetTexCoord(0,1,0,1)
                currentcheckbutton:GetHighlightTexture():SetTexCoord(0,1,0,1)
                currentcheckbutton:GetDisabledTexture():SetTexCoord(0,1,0,1)
            end

            --get checked value for displayed profile  and texture and set accordingly
            currentcheckbutton:SetChecked(TMAprofiles[TMAselectedprofilenums[1]][addonname])
            currentcheckbutton:SetNormalTexture("Interface\\Buttons\\UI-CheckBox-Up") --set them all to default

            issecondary = false
            for j =2,#TMAselectedprofilenums do --only show the primary [1] profile with normal texture
                if(TMAprofiles[TMAselectedprofilenums[j]]) then
                    if(TMAprofiles[TMAselectedprofilenums[j]][addonname]) then  --if even one profile is selected, check it
                        issecondary = true
                    end
                end
            end

            --currentcheckbutton:SetChecked(value)
            if (issecondary) then
                currentcheckbutton:SetNormalTexture("Interface\\Buttons\\UI-CheckBox-Check-Disabled")
            end

            -- all addons that are marked in the 'always load' profile to display differently in the other profiles
            local thealwaysprofile
            thealwaysprofile = TMAgetprofilenum(TMAALWAYSPROFILE)

            -- if its checked in the always list, and the currently displayed list is not that always list, change the check
    	    if(thealwaysprofile and addonnumber) then
        	    name,_,_, _, _, _, _ = GetAddOnInfo(addonnumber)
        	    if(TMAprofiles[thealwaysprofile][name]) and not (thealwaysprofile == TMAselectedprofilenums[1]) then
        	       currentcheckbutton:SetNormalTexture("Interface\\Buttons\\UI-CheckBox-Check-Disabled")
        	    end
            end

			
            --set stuff for when we click it and mouseover
            currentcheckbutton.name = addonname
            currentbutton.name = addonname
            currentcheckbutton.addonnumber = addonnumber
            currentbutton.addonnumber = addonnumber
            currentbutton:SetText(addontitle)
            currentbutton:Show()
			
			
			--TMAprint("|c00ffff00Currentcheckbutton?")
			--TMAprint(currentcheckbutton)
			--TMAprint("|c00ffff00Currentbutton?")
			--TMAprint(currentbutton)

        end --end for rowsthatcanfit
		
		if (TMAgrouping) then
			TMAcollapseallbutton:Show()
			--The collapse all button stuff
			if (not TMAcollapseall) then
				TMAcollapseallbutton:SetPushedTexture("Interface\\Minimap\\UI-Minimap-ZoomOutButton-Down")
				TMAcollapseallbutton:SetNormalTexture("Interface\\Minimap\\UI-Minimap-ZoomOutButton-Up")
				TMAcollapseallbutton:SetHighlightTexture("Interface\\Minimap\\UI-Minimap-ZoomOutButton-Up")
			else
				TMAcollapseallbutton:SetPushedTexture("Interface\\Minimap\\UI-Minimap-ZoomInButton-Down")
				TMAcollapseallbutton:SetNormalTexture("Interface\\Minimap\\UI-Minimap-ZoomInButton-Up")
				TMAcollapseallbutton:SetHighlightTexture("Interface\\Minimap\\UI-Minimap-ZoomInButton-Up")
			end
		else

			TMAcollapseallbutton:Hide()
		end

    else
        TMAaddonframe:Hide()
    end


    ------------------=================----------------
    --now do it all again for the profile list  --!!  yey   !!
    ---------------------------------------------------
    
    local ourscrollbar = getglobal(TMA_PROFILE_LIST_NAME.."scrollbarScrollBar")
    local ourscrollbarframe = getglobal(TMA_PROFILE_LIST_NAME.."scrollbar")
    local newheight = (#TMAprofiles + 2) * TMA_ROW_HEIGHT  --no idea why the 2 but its needed

    TMAprofileframe:SetHeight(math.min(TMA_FRAME_HEIGHT,newheight))
    if(newheight < TMA_FRAME_HEIGHT) then
        ourscrollbar:Hide()
        ourscrollbarframe:Hide()
    else
        ourscrollbar:Show()
        ourscrollbarframe:Show()
    end
    
    

    --figure out how many rows can fit
    local rtcf = TMArowsthatcanfit(TMA_PROFILE_LIST_NAME)
    --set scroll bar limits    
    ourscrollbar:SetMinMaxValues(0,math.max((#TMAprofiles)-rtcf,0))
    --get the scroll bar value
	offset = ourscrollbar:GetValue()
	
    
    TMAhideallbuttons() --this is when we redraw the size of the frames
    

    --create that many buttons and check buttons
    for i=1,rtcf do

        --check if the button exists already  --checkbutton firsr, then regular button
        currentcheckbutton = getglobal(TMA_PROFILE_LIST_NAME.."checkbutton"..i)
        if not currentcheckbutton then
            TMAcreateprofilerows(i)
        end
        currentbutton = getglobal(TMA_PROFILE_LIST_NAME.."button"..i)
        currentcheckbutton = getglobal(TMA_PROFILE_LIST_NAME.."checkbutton"..i)

        
        --display valid item in current button
        numtodisplay = offset + i
        --set text
        
        if(TMAprofiles[numtodisplay]) then
			local profilename = TMAprofiles[numtodisplay].profilename
            currentcheckbutton.number = numtodisplay
            currentbutton:SetText(profilename)
            currentbutton:Show()
            currentcheckbutton:Show()
        else
           currentcheckbutton:Hide()
           currentbutton:Hide()
        end
        currentcheckbutton:SetChecked(false)
		
		--show last loaded as green
		if(TMAlastloadedprofilenums and TMAlastloadedprofilenums[1]) then
			local tmafont 
			for j = 1,#TMAlastloadedprofilenums do
				if(TMAlastloadedprofilenums[j] == numtodisplay) then
					--dammit they took out SetTextColor???
						currentbutton:SetNormalFontObject(GameFontNormal); 
					    tmafont = currentbutton:GetNormalFontObject(); 
						tmafont:SetTextColor(.1, 1, 0.3, 1.0); --yellow?
						currentbutton:SetNormalFontObject(tmafont); 
				end
			end
		end

   end
   
   --get checked value for displayed profile and set accordingly
   for i=1,#TMAselectedprofilenums do
        if(TMAselectedprofilenums[i]) then
           currentcheckbutton = getglobal(TMA_PROFILE_LIST_NAME.."checkbutton"..TMAselectedprofilenums[i]-offset)
           if (currentcheckbutton) then
                if (currentcheckbutton.number) then
                   if (currentcheckbutton.number == TMAselectedprofilenums[i]) then
                        currentcheckbutton:SetChecked(true)
                   end
                end
           end
        end
    end
--sort dropdown
   if(TMAsortmethodnum) then
       TMAsortmenubutton:SetText(TMAsortmethods[TMAsortmethodnum].caption)
   else
       TMAsortmenubutton:SetText("Sort By:")
   end
   
   TMAgamemenubuttonstuff()
     
   TMAsavesettings()
  
end --end update

function TMAgamemenubuttonstuff()
	if (TMAhidegamemenubutton == true) then
		TMAgamemenubutton:Hide()
		-- resize the blizzard menu
		GameMenuFrame:SetHeight(TMAoriggamemenuheight);
		GameMenuButtonLogout:SetPoint("TOP", GameMenuButtonMacros, "BOTTOM", 0, -1);
	else
		TMAgamemenubutton:Show()	
		-- resize the blizzard menu
		GameMenuFrame:SetHeight(TMAoriggamemenuheight + TMAgamemenubutton:GetHeight());
		GameMenuButtonLogout:SetPoint("TOP", TMAgamemenubutton, "BOTTOM", 0, -1);
	end
end

function TMAcreatedisplaylist()
--create addon display list
	local tempaddondisplaylist
	tempaddondisplaylist = {}
    TMAaddondisplaylist = {}

	--if we dont want any grouping to show
	if not (TMAgrouping) and (TMAgroups) then
		TMAgroups = nil
	end
	
	--if we do want grouping enabled
	if(TMAgrouping) and (not TMAgroups) then
		TMAsetupgroups()  --recreate out TMAgroups table
	end
	
	
    --just add non-groups.  groups will come after the sorting.
    for i=1,GetNumAddOns() do
        name,title,notes, _, _, _, _ = GetAddOnInfo(i)
        if ((not TMAisgrouped(name)) or TMAisheader(name)) then
           --add it to our 'display' list
           ourstruct = {}
           ourstruct.name = name
           ourstruct.title = title
           ourstruct.notes = notes
           ourstruct.addonnumber = i
           table.insert(tempaddondisplaylist,ourstruct)
        end
    end
    
    if(TMAsortmethodnum) then
        local TMAsortfunc = TMAsortmethods[TMAsortmethodnum].func
        table.sort(tempaddondisplaylist,TMAsortfunc)
    end
    
    --add kids

	local prefix,addonname ,addonnumber
	for j = 1,#tempaddondisplaylist do
		--TMAprint("#"..j.." : "..tempaddondisplaylist[j].name)
		table.insert(TMAaddondisplaylist,tempaddondisplaylist[j])
		
		if (TMAisheader(tempaddondisplaylist[j].name)) then
			prefix = string.sub(TMAisheader(tempaddondisplaylist[j].name),1,TMACHARSTOCOMP)
			if not (TMAgroups[prefix].collapsed) then
				for i = 2, #TMAgroups[prefix].kids do  --this stuff was set up when we created TMAgroups
				   addonnumber = TMAgroups[prefix].kids[i].addonnumber
				   local name,title,notes, _, _, _, _ = GetAddOnInfo(addonnumber)
				   ourstruct = {}
				   ourstruct.name = name
				   ourstruct.title = title
				   ourstruct.notes = notes
				   ourstruct.addonnumber = addonnumber
				   table.insert(TMAaddondisplaylist,ourstruct)
				end
			end
			
		else
			--debugging
			--TMAprint("name : "..TMAaddondisplaylist[j].name.."   is NOT a header")

		end
	end
	
	--TMAprint(TMAaddondisplaylist)
end



function TMAhideallbuttons()
    local i = 1
    local exit,currentcheckbutton,currentbutton
    while (not exit) do
        currentcheckbutton = getglobal(TMA_PROFILE_LIST_NAME.."checkbutton"..i)
        currentbutton = getglobal(TMA_PROFILE_LIST_NAME.."button"..i)
        if (currentcheckbutton) then
           currentcheckbutton:Hide()
           currentbutton:Hide()
        else
            exit = true

        end
        i=i+1
    end
end


function TMAsetkids(this,profilenum)
   if not profilenum then profilenum = 1 end;
   if(TMAisheader(this.name)) then
      local nextaddon,exit,j
      j = this.addonnumber
      exit = false
      while (not exit) do
          j=j+1
          if(j > GetNumAddOns()) then
             exit = true
          else   
              nextaddon = GetAddOnInfo(j)
              if(not nextaddon) then
                  exit = true
              else
                  if(TMAisgrouped(nextaddon) and (not TMAisheader(nextaddon))) then
                     --nextbutton:SetChecked(this:GetChecked()) 
                     TMAprofiles[TMAselectedprofilenums[profilenum]][nextaddon] = TMAprofiles[TMAselectedprofilenums[profilenum]][this.name]  --set it to the PARENT value
                  else
                    exit = true    
                  end
              end
          end
      end
   end
end

function TMAsetdependencies(this,profilenum)
-- check our dependancies, and if we have some, enable them too
   if TMAprofiles[TMAselectedprofilenums[1]][this.name] then  --if it's checked in the main/first profile
      local deps = {}
      deps = {GetAddOnDependencies(this.name)}

      if(deps) then
          for i = 1,#deps do
            TMAprint(deps)
               TMAprofiles[TMAselectedprofilenums[profilenum]][deps[i]] = true
          end
      end
   end
end


function TMAisgrouped(name)
    if(TMAgroups and name) then
        if (TMAgroups[string.sub(name,1,TMACHARSTOCOMP)]) then
            return string.sub(name,1,TMACHARSTOCOMP)
        else
            return false
        end

    end
    return false
end

function TMAisdisabled(addonname)
	if not addonname then return false end;
    local enabled
    _,_,_,enabled = GetAddOnInfo(addonname)
    if(enabled) then
        return false
    else
        return true
    end

end

function TMAiscollapsed(name)
    if(name and TMAisgrouped(name)) then
       return TMAgroups[string.sub(name,1,TMACHARSTOCOMP)].collapsed
    end
   return false
end

function TMAisheader(name)
    local curgroup
    if not (name and TMAgroups) then return false end;
    curgroup = TMAgroups[string.sub(name,1,TMACHARSTOCOMP)]
    if(curgroup) then
      if(curgroup.header == name) then
        return string.sub(name,1,TMACHARSTOCOMP)
      end
    end
    return false
end



function TMAsavesettings()
   ---------- -- save our TMAprofile data structure to the larger TMAsettings so it will be saved globally amongnst all players/realms

   if TMAprofiles then
        TMAprint("|c0044eeffSaving settings.")

      if not (TMAsettings) then
	   TMAsettings = {}
      end
      
      if not TMAsettings.servers then
	    TMAsettings.servers = {}
      end
      local playerName = UnitName("player");
      local serverName = GetCVar("realmName");
      -- Do nothing if player name is not available
      if (playerName == nil or playerName == UNKNOWNOBJECT or playerName == UKNOWNBEING) then
	    return;
      end
      if not TMAsettings.servers[serverName] then
	    TMAsettings.servers[serverName] = {}
      end
      
      if not TMAsettings.servers[serverName][playerName] then
	    TMAsettings.servers[serverName][playerName] = {}
      end
      
      if not (TMAsettings.servers[serverName][playerName].TMAselectedprofilenums) then
         TMAsettings.servers[serverName][playerName].TMAselectedprofilenums = {}
      end
      TMAsettings.servers[serverName][playerName].TMAselectedprofilenums = TMAselectedprofilenums
      
      TMAprofiles.sortmethodnum = TMAsortmethodnum
	  if not (TMAprofiles.TMAlastloadedprofilenums) then
		TMAprofiles.TMAlastloadedprofilenums = {}
	  end
	  TMAprofiles.TMAlastloadedprofilenums = TMAlastloadedprofilenums
      
      TMAsettings.servers[serverName][playerName] = TMAprofiles
	  
	  TMAsettings.TMAcollapseall = TMAcollapseall
   end

   if TMAprofileframe then
      if not TMAsettings then
	    TMAsettings = {}
      end
      local point, relativeTo, relativePoint, xOfs, yOfs
      point, relativeTo, relativePoint, xOfs, yOfs = TMAprofileframe:GetPoint(TOPLEFT)
      TMAsettings.point = point
      TMAsettings.relativeTo = relativeTo
      TMAsettings.relativePoint = relativePoint
      TMAsettings.xOfs = xOfs
      TMAsettings.yOfs = yOfs
   end
   
   TMAsettings.hidegamemenubutton=TMAhidegamemenubutton
   TMAsettings.grouping = TMAgrouping
   TMAsettings.hidetooltips = TMAhidetooltips
   
   TMAprint("End |c0044eeffSaving settings.")
end

function createalwaysprofile()

   local thealwaysprofile,tablesize
   thealwaysprofile=TMAgetprofilenum(TMAALWAYSPROFILE)

   if not (thealwaysprofile) then
	-- create the 'always' profile :)
	table.insert(TMAprofiles,{})
	tablesize = table.maxn(TMAprofiles)
	TMAprofiles[tablesize].profilename = TMAALWAYSPROFILE
	TMAprofiles[tablesize]["TooManyAddons"] = true
     end

end


------------------------------------------------------------------------------
-- FMCODE - using blizzards tooltips
function TMAshowtooltip(frame,notes)
	if not (TMAhidetooltips) then
	   if frame:GetRight() >= (GetScreenWidth() / 2) then
			GameTooltip:SetOwner(frame, "ANCHOR_LEFT")
			 else
			GameTooltip:SetOwner(frame, "ANCHOR_RIGHT")
		 end
		 if(notes) then
			GameTooltip:SetText(notes, .5, 1, 1, 1, 1)
			GameTooltip:Show()
		 end
	end
end

function TMAhidetooltip()
	GameTooltip:Hide()
end
-- /FMCODE
------------------------------------------------------------------------------

function TMAgetprofilenum(input)
   local i,TMAprofilenum
   for i = 1, #TMAprofiles do
      if(TMAprofiles[i].profilename == input) then
    	 return i
      end
   end
   return nil
end

function TMAloadprofile(profile)
    local i,j
    local thealwaysprofile, j, name,title,curprofile
    if (profile) then
    
        --TMAprint(profile)
		
		--store what we loaded so its green next time
		TMAlastloadedprofilenums = {}
		TMA_tcopy(TMAlastloadedprofilenums,TMAselectedprofilenums)
		TMAsavesettings()

        thealwaysprofile = TMAgetprofilenum(TMAALWAYSPROFILE)
    	if not (thealwaysprofile) then
    	   thealwaysprofile = profile
    	end
    	
        if(type(profile) == "string") then  --done via the /slash command
           TMAloadprofile(TMAgetprofilenum(profile))
        elseif(type(profile) == "table") then

            --first turn off all addons
           for i=1,GetNumAddOns() do
               DisableAddOn(i)
           end
			--now turn on thealwaysprofile stuff
		   curprofile = thealwaysprofile
		   if (curprofile and TMAprofiles[curprofile]) then
			   for i=1,GetNumAddOns() do
				  name,_,_, _, _, _, _ = GetAddOnInfo(i)
				  if(TMAprofiles[curprofile][name]) then
					  EnableAddOn(i)
				  end
			   end
		   end
       
           for i=1,#profile do
               TMAprint(type(TMAselectedprofilenums[i]))
              if(type(TMAselectedprofilenums[i]) == "number") then  --it'd better be a number X_X
                  curprofile = profile[i]
                  for j=1,GetNumAddOns() do
                      name,_,_, _, _, _, _ = GetAddOnInfo(j)
                      if(TMAprofiles[curprofile][name]) then
                          EnableAddOn(j)
                      end
                  end
              end
           end


           
           ---massive drum roll....
           ReloadUI()
           
       elseif(type(profile) == "number") then
        	for i=1, GetNumAddOns() do
        	   name,title,_, _, _, _, _ = GetAddOnInfo(i)
        	   -- we enable every addon in TWO profiles - the selected one, and the always profile
        	   if(TMAprofiles[profile][name]) or (TMAprofiles[thealwaysprofile][name]) then
        		EnableAddOn(i)
        	   else
        		DisableAddOn(i)
        	   end
        	end
        	-- drum roll please
        	ReloadUI()
        end
    else
      DEFAULT_CHAT_FRAME:AddMessage("You do not have a profile selected.")
   end
end


-- tcopy: recursively copy contents of one table to another.  from wowwiki
 function TMA_tcopy(to, from)   -- "to" must be a table (possibly empty)
   for k,v in pairs(from) do
     if(type(v)=="table") then
       to[k] = {}
       TMA_tcopy(to[k], v);
     else
       to[k] = v;
     end
   end
 end

--
-- Decorator Pattern Text Colorization Functions
-- Same as crayonlib
--
local CLR = {}
CLR.COLOR_NONE = nil
function CLR:Colorize(hexColor, text)
    if text == nil then text = "" end
    if hexColor == CLR.COLOR_NONE then
        return text
    end
    return "|cff" .. tostring(hexColor or 'ffffff') .. tostring(text) .. "|r"
end

function CLR:Label(txt) return CLR:Colorize('ffff7f', txt) end
function CLR:Red(txt) return CLR:Colorize('cc0000', txt) end

function TMAHideAddonTooltip()
    GameTooltip:Hide()
end
 
--thank you addon control panel
function TMAShowAddonTooltip(frame)
	if not (TMAhidetooltips) then
		local index = frame.addonnumber
		if not index then return end
		local name, title, notes, enabled, loadable, reason, security = GetAddOnInfo(index)
		local author = GetAddOnMetadata(name, "Author")
		local deps = { GetAddOnDependencies(index) }

		GameTooltip:SetOwner(frame)
		if title then
		  GameTooltip:AddLine(title)
		else
		  GameTooltip:AddLine(name, 1,0.78,0,1)
		end
		if notes then
			GameTooltip:AddLine(notes,1,1,1,1) --1111 for word wrapping
		end
		if author then
			GameTooltip:AddLine(string.format("%s: %s", CLR:Label("Author"), author))
		end
		if enabled then
			GameTooltip:AddLine(string.format("%s: %s", CLR:Label("Status"), "Enabled"))
		else
			GameTooltip:AddLine(string.format("%s: %s", CLR:Label("Status"), CLR:Red("Disabled")))
		end
		if(TMAsettings.dates[name]) then
			local tmadate = tostring(TMAsettings.dates[name])
			GameTooltip:AddLine(string.format("%s: %s/%s/%s", CLR:Label("Date First Seen"), string.sub(tmadate,3,4), string.sub(tmadate,5,6),string.sub(tmadate,1,2)))
		end

		local depLine
		local dep = deps[1]
		if dep then
			depLine = CLR:Label("Dependencies")..": "..dep
			for i = 2, #deps do
				dep = deps[i]
				if dep and dep:len()>0 then
					depLine = depLine..", "..dep
				end
			end
			GameTooltip:AddLine(depLine,1,1,1,1)
		end

		UpdateAddOnMemoryUsage()
		local mem = GetAddOnMemoryUsage(index)
		local text2
		if (mem > 0) then
			if mem > 1024 then
				text2 = ("|cff8080ff%.2f|r MB"):format(mem / 1024)
			else
				text2 = ("|cff8080ff%.0f|r KB"):format(mem)
			end

			GameTooltip:AddLine(CLR:Label("Memory Usage")..": "..text2, 1,0.78,0, 1)
		end
		
		GameTooltip:Show()
	end

end

 
 TMA_onload()