--TMAdebug = true

TMAprintstack = -1
function TMAprint(message)
   if(TMAdebug) then
      local stack, filler
      if not message then
	  	 DEFAULT_CHAT_FRAME:AddMessage("Nil or False")
		 return false
      end
      TMAprintstack=TMAprintstack+1
      local filler=""
      for stack=1,TMAprintstack do
	  	 filler=filler.."--"
      end
      if (type(message) == "table") then
	  	-- DEFAULT_CHAT_FRAME:AddMessage("its a table.  length="..TMA_tcount(message))
	 	local i
	 	for k,v in pairs(message) do

	    	DEFAULT_CHAT_FRAME:AddMessage(filler.."(key)   "..k)
	    	TMAprint(v)
	 	end
      elseif (type(message) == "userdata") then

      else
	  	  if(TMAprintstack>0) then
	    	 DEFAULT_CHAT_FRAME:AddMessage(filler.."(value) "..tostring(message))
	 	 else
	    	 DEFAULT_CHAT_FRAME:AddMessage(filler..tostring(message))
	 	 end
	end
      TMAprintstack=TMAprintstack-1
   end
end



TMA_FRAME_HEIGHT = 505
TMA_FRAME_WIDTH = 250
TMA_HEIGHT_OF_BUTTON = 30
TMA_COLUMN_WIDTH = 180
TMA_GAP_BETWEEN_BUTTONS = 10
TMA_ROW_HEIGHT = TMA_HEIGHT_OF_BUTTON - TMA_GAP_BETWEEN_BUTTONS
TMA_ROWS_THAT_CAN_FIT = math.floor(TMA_FRAME_HEIGHT / TMA_ROW_HEIGHT)
TMA_ADDON_LIST_NAME = "TMAaddonlist"
TMA_PROFILE_LIST_NAME = "TMAprofilelist"
TMAALWAYSPROFILE = "Always Load These Addons"
TMACHARSTOCOMP = 4
TMAADDONSTOMAKEAGROUP = 3

TMACTRLTOOLTIP="Changes to the addon list will affect all selected profiles."
TMASHIFTTOOLTIP="Click to select everything between here and your previous click."
TMADEFAULTTOOLTIP="Hold Ctrl or Shift to select multiple or groups of profiles."
function Onenterfunction(this)
	if(IsControlKeyDown()) then
		TMAshowtooltip(this,"Changes to the addon list will affect all selected profiles.")
	elseif(IsShiftKeyDown()) then
		TMAshowtooltip(this,"Click to select everything between here and your previous click.")
	else
		TMAshowtooltip(this,"Hold Ctrl or Shift to select multiple or groups of profiles.")
	end
end


function TMAcreateinterface()
	-- create our frames
	CreateCheckList(TMA_ADDON_LIST_NAME)
	CreateCheckList(TMA_PROFILE_LIST_NAME)
	local TMAaddonframe = getglobal(TMA_ADDON_LIST_NAME.."frame")
	local TMAprofileframe = getglobal(TMA_PROFILE_LIST_NAME.."frame")


	--wowwiki says this will make frames closable with 'esc'
	tinsert(UISpecialFrames,TMAaddonframe:GetName());
	tinsert(UISpecialFrames,TMAprofileframe:GetName());


	TMAaddonframe:SetHeight(TMA_FRAME_HEIGHT)
	TMAaddonframe:SetWidth(TMA_FRAME_WIDTH)
	TMAaddonframe:SetPoint("topleft",TMAprofileframe,"topright", 150,0)
	TMAprofileframe:SetPoint("topleft",100,-100)
	TMAprofileframe:SetMovable(true)
	TMAprofileframe:EnableMouse(true)
	--create our custom scripts
	TMAaddonframe:SetScript("OnShow",function()
		TMAupdate()
	end)
	TMAprofileframe:SetScript("OnShow",function()
		TMAupdate()
	end)
	TMAprofileframe:SetScript("OnMouseDown",function()
		TMAprofileframe:StartMoving()
	end)
	TMAprofileframe:SetScript("OnMouseUp",function()
		TMAprofileframe:StopMovingOrSizing()
	end)

	local ourscrollbar = getglobal(TMA_PROFILE_LIST_NAME.."scrollbar")
	ourscrollbar:SetPoint("left")
	ourscrollbar:SetScript("OnVerticalScroll",function()
		--DEFAULT_CHAT_FRAME:AddMessage("scrolling...")
		ourscrollbar_Update(TMA_PROFILE_LIST_NAME);
		TMAupdate()
	end)
	ourscrollbar:SetScript("OnShow",function()
		ourscrollbar_Update(TMA_PROFILE_LIST_NAME)
		TMAupdate()
	end)

	TMAaddonframe:Hide()
	TMAprofileframe:Hide()

	local name, title, enabled

------ clear all button
		TMAclearallbutton = CreateFrame("Button",nil,TMAaddonframe,"UIPanelButtonTemplate")
			TMAclearallbutton:SetHeight(32)
			TMAclearallbutton:SetWidth(100)
			TMAclearallbutton:SetText("Clear All")
			TMAclearallbutton:SetPoint("TOPleft",TMAaddonframe,"Topright",25,-32)
			TMAclearallbutton:SetScript("OnClick",function()
                local i,j
                for i=1,#TMAselectedprofilenums do
                   local name, title
			       for j=1, GetNumAddOns() do
    				  if(TMAprofiles[TMAselectedprofilenums[i]]) then
    				     name,title,_, _, _, _, _ = GetAddOnInfo(j)
    				     TMAprofiles[TMAselectedprofilenums[i]][name] = false
    				  end
			       end
                end
			    TMAupdate()
			 end)

------- enable all button
		TMAenableallbutton = CreateFrame("Button",nil,TMAaddonframe,"UIPanelButtonTemplate")
			TMAenableallbutton:SetHeight(32)
			TMAenableallbutton:SetWidth(100)
			TMAenableallbutton:SetText("Enable all")
			TMAenableallbutton:SetPoint("TOP",TMAclearallbutton,"bottom",0,-32)
			TMAenableallbutton:Enable()
			TMAenableallbutton:SetScript("OnClick",function()
                local i,j
                for i=1,#TMAselectedprofilenums do
                   local name, title
			       for j=1, GetNumAddOns() do
    				  if(TMAprofiles[TMAselectedprofilenums[i]]) then
    				     name,title,_, _, _, _, _ = GetAddOnInfo(j)
    				     TMAprofiles[TMAselectedprofilenums[i]][name] = true
    				  end
			       end
                end
				TMAupdate()
			end)

---------------------  'use current addons' button
		TMAresetbutton = CreateFrame("Button",nil,TMAaddonframe,"UIPanelButtonTemplate")
			TMAresetbutton:SetHeight(32)
			TMAresetbutton:SetWidth(100)
			TMAresetbutton:SetText("Add Enabled")
			TMAresetbutton:SetPoint("TOP",TMAenableallbutton,"bottom",0,-32)
			TMAresetbutton:SetScript("OnEnter",function()
                TMAshowtooltip(this,"Add currently enabled addons to the profile.")
            end)
			TMAresetbutton:SetScript("OnLeave",function()
                TMAhidetooltip()
            end)
			TMAresetbutton:SetScript("OnClick",function()
				local enabled,name,title,i,j
				for i=1, GetNumAddOns() do
					name,title,_, enabled, _, _, _ = GetAddOnInfo(i)
					if(enabled) then
                		for j = 1,#TMAselectedprofilenums do
                		   TMAprofiles[TMAselectedprofilenums[j]][name] = enabled  --test this
                        end
    				end
                end
				TMAupdate()
			end)

------------ create new profile button
		TMAcreatenewprofilebutton = CreateFrame("Button",nil,TMAprofileframe,"UIPanelButtonTemplate")
			TMAcreatenewprofilebutton:SetHeight(32)
			TMAcreatenewprofilebutton:SetWidth(100)
			TMAcreatenewprofilebutton:SetText("New Profile")
			TMAcreatenewprofilebutton:SetPoint("bottomLEFT",TMAprofileframe,"Topleft",0,0)
			--TMAcreatenewprofilebutton:SetPoint("TOPLEFT")
			TMAcreatenewprofilebutton:SetScript("OnClick",function()
				if not (TMAprofiles) then
					TMAprofiles = {}
				end
				table.insert(TMAprofiles,{})
				--get the index of the table we just created
				local index = table.maxn(TMAprofiles)
				TMAselectedprofilenums = {}
				TMAselectedprofilenums[1] = index
				TMAprofiles[index].profilename = TMAnewprofileeditbox:GetText()
				TMAnewprofileeditbox:SetText("")
				TMAupdate()
			end)

-- -------------------------the edit box
		TMAnewprofileeditbox = CreateFrame("EditBox",nil,TMAprofileframe,"InputBoxTemplate")
			TMAnewprofileeditbox:SetFocus()
			TMAnewprofileeditbox:SetAutoFocus(false)
			TMAnewprofileeditbox:SetHeight(32)
			TMAnewprofileeditbox:SetWidth(100)
			TMAnewprofileeditbox:SetText("Profile")
			TMAnewprofileeditbox:SetPoint("LEFT",TMAcreatenewprofilebutton,"RIGHT")
			TMAnewprofileeditbox:SetFrameLevel(3)
			TMAnewprofileeditbox:SetScript("OnEscapePressed",function()
				TMAnewprofileeditbox:ClearFocus()
				TMAupdate()
			end)
			TMAnewprofileeditbox:SetScript("OnEnterPressed",function()
				TMAcreatenewprofilebutton:Click()

			end)
			TMAnewprofileeditbox:SetScript("OnEditFocusGained",function()
					TMAnewprofileeditbox:SetText("")
			end)


------------------------------ delete button --------------------------
		TMAdeletebutton = CreateFrame("Button",nil,TMAprofileframe,"UIPanelButtonTemplate")
			TMAdeletebutton:SetHeight(32)
			TMAdeletebutton:SetWidth(100)
			TMAdeletebutton:SetText("Delete Profile")
			TMAdeletebutton:SetPoint("topleft",TMAprofileframe,"topright",25,-32)
			TMAdeletebutton:SetScript("OnEnter",function()
			      TMAshowtooltip(this,"Delete selected profiles")
			end)
			TMAdeletebutton:SetScript("OnLeave",function()
                TMAhidetooltip()
			end)

			TMAdeletebutton:SetScript("OnClick",function()
                local j
      		    for j = 1,#TMAselectedprofilenums do
                    --TMAprofiles[TMAselectedprofilenums[j]].profilename = nil
				    table.remove(TMAprofiles,TMAselectedprofilenums[j])
                end
				local newprofilenum = TMAselectedprofilenums[1]
				TMAselectedprofilenums = {}
				TMAselectedprofilenums[1] = newprofilenum
				TMAupdate()
			end)

----------------- load addon button
		TMAloadbutton = CreateFrame("Button",nil,TMAprofileframe,"UIPanelButtonTemplate")
			TMAloadbutton:SetHeight(32)
			TMAloadbutton:SetWidth(100)
			TMAloadbutton:SetText("Load profile")
			TMAloadbutton:SetPoint("TOP",TMAdeletebutton,"bottom",0,-32)
			TMAloadbutton:SetScript("OnClick",function()
			      TMAloadprofile(TMAselectedprofilenums)
			end)
			TMAloadbutton:SetScript("OnEnter",function()
			      TMAshowtooltip(this,"Reload your UI, enabling checked addons, and disabling non-checked addons")
			end)
			TMAloadbutton:SetScript("OnLeave",function()
                TMAhidetooltip()
			end)
			
 	--------------------------- game menu button --------------------------------------
		
		TMAgamemenubutton = CreateFrame("Button",nil,GameMenuFrame,"GameMenuButtonTemplate")
			TMAgamemenubutton:SetText("Addons")
			TMAgamemenubutton:SetPoint("TOP",GameMenuButtonMacros,"bottom",0,-1)

			--an incompatability
			--if(GameMenuButtonMoveAnything) then   --moveanything seems to have moved its button to the bottom of the list :)
--			   TMAgamemenubutton:SetPoint("TOP",GameMenuButtonMoveAnything,"bottom",0,-1)
			--end
			if(myGameMenuButtonReloadUI) then
			   TMAgamemenubutton:SetPoint("TOP",myGameMenuButtonReloadUI,"bottom",0,-1)
			end
			if(GameMenuButtonSuperMacro) then
			   TMAgamemenubutton:SetPoint("TOP",GameMenuButtonSuperMacro,"bottom",0,-1)
			end
			if(GameMenuButtonAddOns) then  --acp
			   TMAgamemenubutton:SetPoint("TOP",GameMenuButtonAddons,"bottom",0,-1)
			end

			TMAgamemenubutton:Hide()
			TMAgamemenubutton:SetScript("OnClick",function()
				PlaySound("igMainMenuOption");
				HideUIPanel(GameMenuFrame);
				TMA();
			end)
			
			TMAoriggamemenuheight = GameMenuFrame:GetHeight()
			
------------------------ the dropdown menu to load profiles -------------------------
TMAprint("|c00ff0033 creating dropdownmenu")
		TMAdropDownMenu = CreateFrame("Frame", "TMAdropDownMenu", TMAprofileframe, "UIDropDownMenuTemplate");
		UIDropDownMenu_SetWidth(TMAdropDownMenu,TMA_FRAME_WIDTH/2,8)
		TMAdropDownMenu:SetPoint("Top",TMAprofileframe,"bottom",0,0)


		--invisible button for text
		TMAprint("|c00ff00aa creating invisible button for dropdownmenu")
		TMAdropdownmenubutton = CreateFrame("Button",nil,TMAdropDownMenu)
		TMAdropdownmenubutton:SetText("Import Profiles")
		TMAdropdownmenubutton:SetNormalFontObject(GameFontNormal)
		TMAdropdownmenubutton:SetPoint("topleft",40,0)
		TMAdropdownmenubutton:SetWidth(80)
		TMAdropdownmenubutton:SetHeight(32)
		TMAdropdownmenubutton:Disable()



------------------------ the close button [X] ---------------

		TMAclosebutton = CreateFrame("button",nil,TMAprofileframe,"UIPanelButtonTemplate")
		TMAclosebutton:SetWidth(16)
		TMAclosebutton:SetHeight(20)
		TMAclosebutton:SetPoint("TopRight",0,0)
		TMAclosebutton:SetText("x")
		TMAclosebutton:SetScript("OnClick",function()
						      TMAprofileframe:Hide()
						      TMAaddonframe:Hide()
						   end)



        TMAprint("|c00ff0033 creating Sorting dropdownmenu")
		TMAsortMenu = CreateFrame("Frame", "TMAsortMenu", TMAaddonframe, "UIDropDownMenuTemplate");
		UIDropDownMenu_SetWidth(TMAsortMenu,TMA_FRAME_WIDTH/2,8)
		TMAsortMenu:SetPoint("Top",TMAaddonframe,"bottom",0,0)
		--invisible button for text
		TMAsortmenubutton = CreateFrame("Button",nil,TMAsortMenu)
		TMAsortmenubutton:SetText("Sort By:")
		TMAsortmenubutton:SetNormalFontObject(GameFontNormal)
		TMAsortmenubutton:SetPoint("topleft",40,0)
		TMAsortmenubutton:SetWidth(80)
		TMAsortmenubutton:SetHeight(32)
		TMAsortmenubutton:Disable()
		
		
		--a Collapse All button
		TMAcollapseallbutton = CreateFrame("button","TMAcollapseallbutton",TMAaddonframe)
		TMAcollapseallbutton:SetHeight(20)
		TMAcollapseallbutton:SetWidth(20)
		TMAcollapseallbutton:SetPoint("bottom",TMAaddonframe,"topleft",50,0)
		TMAcollapseallbutton:SetPushedTexture("Interface\\Minimap\\UI-Minimap-ZoomInButton-Down")
		TMAcollapseallbutton:SetNormalTexture("Interface\\Minimap\\UI-Minimap-ZoomInButton-Up")
		TMAcollapseallbutton:SetHighlightTexture("Interface\\Minimap\\UI-Minimap-ZoomInButton-Up")
		TMAcollapseallbutton:GetHighlightTexture():SetTexCoord(0,.86,0,.86)
		TMAcollapseallbutton:GetNormalTexture():SetTexCoord(0,.86,0,.86)
		TMAcollapseallbutton:GetPushedTexture():SetTexCoord(0,.86,0,.86)
		TMAcollapseallbutton:GetHighlightTexture():SetAllPoints()
		TMAcollapseallbutton:SetAlpha(0.5)
		TMAcollapseallbutton:SetScript("OnClick",function()
			
			
			--TMAprint("Number of tmagroups = "..#TMAgroups.."  collapsed value of 1 ="..tostring( TMAgroups[1].collapsed))
			TMAprint("CLEEEKKK.  TMAgroups?")
			--TMAprint(TMAgroups)
			
			TMAcollapseall = not TMAcollapseall
			if(TMAgroups) then
				for key,value in pairs(TMAgroups) do
					TMAprint("key = "..key)
					TMAgroups[key].collapsed = TMAcollapseall
				end
			
			
				TMAupdate()
			
			end
		end)
		TMAcollapseallbutton:SetScript("OnEnter",function()
			if (TMAcollapseall) then
				notes = "Expand all groups"
			else
				notes = "Collapse all groups"
			end
			TMAshowtooltip(this,notes)
		end)
		TMAcollapseallbutton:SetScript("OnLeave",function()
			TMAhidetooltip()
		end)
			
			
		
end  --end make interface



function TMAcreateoptionframe()


	local Frame = CreateFrame("Frame", "TMAoptions");
	local Text = Frame:CreateFontString(nil, "BACKGROUND", "GameFontHighlight");
	Text:SetText("TooManyAddons is a minimalist and fast addon manager for you addon junkies.");
	Text:SetJustifyH("LEFT");
	Text:SetJustifyV("TOP");
	Text:SetPoint("TOPLEFT", 20, -20);
	Text:SetPoint("BOTTOMRIGHT", -20, 0);
	
	--option1
	local Button;
	Button = CreateFrame("CheckButton", "TMAoption1", Frame, "OptionsCheckButtonTemplate");
	Button:SetPoint("TOPLEFT", 20, -65);
	--Button:SetText("option1")
	getglobal(Button:GetName().."Text"):SetText("Hide Game Menu Button");
	Button.tooltipText = "Hide the 'Addons' button in the game menu"
	Button:SetScript("OnClick",function()
		if this:GetChecked()then
			PlaySound("igMainMenuOptionCheckBoxOff");
			TMAhidegamemenubutton = true
		else
			PlaySound("igMainMenuOptionCheckBoxOn");
			TMAhidegamemenubutton = false
		end
		TMAprint("OPtion 1 clicked.  HIDING? |c0000aaff"..tostring(TMAhidegamemenubutton))
		TMAupdate()
	end);
	
	Button = CreateFrame("CheckButton", "TMAoption2", Frame, "OptionsCheckButtonTemplate");
	Button:SetPoint("TOPLEFT",TMAoption1,"BottomLeft",0, -25);
	getglobal(Button:GetName().."Text"):SetText("Enable Grouping");
	Button.tooltipText = "Group addons with similar names."
	Button:SetScript("OnClick",function()
		if this:GetChecked()then
			PlaySound("igMainMenuOptionCheckBoxOff");
			TMAgrouping = true
		else
			PlaySound("igMainMenuOptionCheckBoxOn");
			TMAgrouping = false
		end
		TMAprint("OPtion 2 clicked.  HIDING? |c0000aaff"..tostring(TMAgrouping))
		TMAupdate()
	end);
	
	
	
	--hide tooltips
	Button = CreateFrame("CheckButton", "TMAoption3", Frame, "OptionsCheckButtonTemplate");
	Button:SetPoint("TOPLEFT",TMAoption2,"BottomLeft",0, -25);
	getglobal(Button:GetName().."Text"):SetText("Disable Tooltips");
	Button.tooltipText = "Too much lag?  Try this."
	Button:SetScript("OnClick",function()
		if this:GetChecked()then
			PlaySound("igMainMenuOptionCheckBoxOff");
			TMAhidetooltips = true
		else
			PlaySound("igMainMenuOptionCheckBoxOn");
			TMAhidetooltips = false
		end
		TMAprint("OPtion 3 clicked.  HideTooltips? |c0000aaff"..tostring(TMAhidetooltips))
		TMAupdate()
	end);
	
	
	
	
	
--[[  --version id
  Text = Frame:CreateFontString(nil, "BACKGROUND", "GameFontNormalSmall");
  Text:SetPoint("BOTTOMRIGHT",-13,13);
  Text:SetText("Version "..tostring(GetAddOnMetadata("TooManyAddons","Version")));
  ]]

  Frame.name = "TooManyAddons";
  InterfaceOptions_AddCategory(Frame);

--[[
  SlashCmdList["TMA"] = function()
    InterfaceOptionsFrame_OpenToCategory("TooManyAddons");
  end
  --SLASH_BaudAFKReporter1 = "/baudafk";
  --SLASH_BaudAFKReporter2 = "/baudafkreporter";
]]


end

function ourscrollbar_Update(name)

  TMAupdate()
  
end

function TMAcreateaddonbutton(i)
    local currentcheckbutton,currentcollapsebutton,currentbutton

    currentcheckbutton = TMACreateCheckButton(TMA_ADDON_LIST_NAME,i)
    currentcheckbutton:SetScript("OnClick",function()
		if (this.name) then
			local newvalue = not TMAprofiles[TMAselectedprofilenums[1]][this.name] --if multiple profiles are clicked, just use the value of the first selected profile
			local i
			for i=1,#TMAselectedprofilenums do 
				TMAprint("selectedprofilenums "..i.."  = "..TMAselectedprofilenums[i])
				TMAprofiles[TMAselectedprofilenums[i]][this.name] = newvalue
				--do we need to expand its group
				TMAsetkids(this,i)
				TMAsetdependencies(this,i)
			end
			TMAupdate()
		end
    end)
    currentcheckbutton:SetScript("OnEnter",function()
        TMAShowAddonTooltip(this)
    end)
    currentcheckbutton:SetScript("OnLeave",function()
        TMAHideAddonTooltip()
    end)


    --button for text
    currentbutton = TMACreateButton(TMA_ADDON_LIST_NAME,i)
    currentbutton:SetScript("OnEnter",function()
        TMAShowAddonTooltip(this)
    end)
    currentbutton:SetScript("OnLeave",function()
        TMAHideAddonTooltip()
    end)


    --the little +/- button
    collapsebutton = CreateFrame("button","TMAcollapsebutton"..i,currentcheckbutton,"UIPanelButtonTemplate")
    collapsebutton:SetHeight(20)
    collapsebutton:SetWidth(20)
    collapsebutton:SetPoint("left",currentcheckbutton,"right")
    collapsebutton:SetPushedTexture("Interface\\Minimap\\UI-Minimap-ZoomInButton-Down")
    collapsebutton:SetHighlightTexture("Interface\\Minimap\\UI-Minimap-ZoomInButton-Up")
    collapsebutton:GetHighlightTexture():SetTexCoord(0,.86,0,.86)
    collapsebutton:GetNormalTexture():SetTexCoord(0,.86,0,.86)
    collapsebutton:GetPushedTexture():SetTexCoord(0,.86,0,.86)
    collapsebutton:GetHighlightTexture():SetAllPoints()
	collapsebutton:SetAlpha(0.5)
    collapsebutton:SetScript("OnClick",function()
        if(this.groupname and TMAgroups) then
            local groupname = this.groupname
    		if (TMAgroups[groupname].collapsed) then
    		   TMAgroups[groupname].collapsed = false
    		else
    		   TMAgroups[groupname].collapsed = true
    		end
    		TMAupdate()
    	end
    end)
    collapsebutton:SetScript("OnEnter",function()
        if(this.groupname and TMAgroups) then
            local notes
            local groupname = this.groupname
    		if (TMAgroups[groupname].collapsed) then
                notes = "Expand addons starting with "..groupname
    		else
                notes = "Collapse addons starting with "..groupname
    		end
            TMAshowtooltip(this,notes)
    	end

    end)
    collapsebutton:SetScript("OnLeave",function()
        TMAhidetooltip()
    end)
end

function TMAcreateprofilerows(i)

    local currentcheckbutton = TMACreateCheckButton(TMA_PROFILE_LIST_NAME,i)
    currentcheckbutton:SetScript("OnEnter",function()
		Onenterfunction(this)
	end)
	
    currentcheckbutton:SetScript("OnLeave",function()

        TMAhidetooltip()
    end)
    currentcheckbutton:SetScript("OnClick",function()
		if(IsShiftKeyDown() and (#TMAselectedprofilenums>0)) then
			local step
			local startnum = TMAselectedprofilenums[#TMAselectedprofilenums]
            if (startnum >= this.number) then
				step=-1
			else
				step=1
			end
			
			if not (IsControlKeyDown()) then
					TMAselectedprofilenums = {}
			end
			for i=startnum,this.number,step do
				table.insert(TMAselectedprofilenums,i)
            end
		elseif(IsControlKeyDown()) then
            --if its already in there, take it out
            local isin = false
            for i=1,#TMAselectedprofilenums do
               if((TMAselectedprofilenums[i] == this.number) and (not isin)) then
                  isin = true
                  table.remove(TMAselectedprofilenums,i)
               end
            end
            if not (isin) then
                table.insert(TMAselectedprofilenums,this.number)
            end
        else
            TMAselectedprofilenums = {}
            TMAselectedprofilenums[1] = this.number
        end
        TMAupdate()
    end)
    
    local currentbutton = TMACreateButton(TMA_PROFILE_LIST_NAME,i)
    currentbutton:SetScript("OnEnter",function()
		Onenterfunction(this)
    end)
    currentbutton:SetScript("OnLeave",function()
        TMAhidetooltip()
    end)
end

function CreateCheckList(name)
	if(getglobal(name.."frame")) then
		--this has already been called.
		return getglobal(name.."frame")
	else
	-- make the global frame
		local ourframe = CreateFrame("Frame",name.."frame",UIParent) 
			ourframe:SetWidth(TMA_FRAME_WIDTH)
			ourframe:SetHeight(TMA_FRAME_HEIGHT)
			ourframe:SetPoint("TOPLEFT",200,-200)
			ourframe:SetBackdrop({bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background",
									edgeFile="Interface\\DialogFrame\\UI-DialogBox-Border",
									tile = false,
									tilesize = 16,
									edgesize = 16,
									insets = { left = 10, right = 10, top = 10, bottom = 10 }})
			ourframe:SetBackdropColor(0,0,0,1)
			ourframe:Hide()

        TMAcreatescrollbar(name)
	end
	return ourframe
end

function TMAcreatescrollbar(name)

   --make the scroll bar for the frame
   local ourframe=getglobal(name.."frame")
	local scrollbarframe = CreateFrame("ScrollFrame",name.."scrollbar",ourframe,"UIPanelScrollFrameTemplate")
	TMAscrollbar = getglobal(scrollbarframe:GetName().."ScrollBar")
	scrollbarframe:SetAllPoints()
   
   local TMAscrollupbutton = getglobal(scrollbarframe:GetName().."ScrollBarScrollUpButton" );
   TMAscrollupbutton:Enable()
   TMAscrollupbutton:SetScript("OnClick",function()
        local ourscrollbar = getglobal(name.."scrollbarScrollBar")
        ourscrollbar:SetValue(ourscrollbar:GetValue() - 1)
   end)
   TMAscrollupbutton:SetScript("OnMouseDown",function()
					      end)  
   TMAscrollupbutton:SetScript("OnMouseUp",function()
					    end)  


   local TMAscrolldownbutton = getglobal(scrollbarframe:GetName().."ScrollBarScrollDownButton" );
   TMAscrolldownbutton:Enable()
   TMAscrolldownbutton:SetScript("OnClick",function()
        local ourscrollbar = getglobal(name.."scrollbarScrollBar")
        ourscrollbar:SetValue(ourscrollbar:GetValue() + 1)
   end)
   TMAscrolldownbutton:SetScript("OnMouseDown",function()
						end)  
   TMAscrolldownbutton:SetScript("OnMouseUp",function()
					      end)  
   scrollbarframe:SetScript("OnVerticalScroll",function()
       TMAupdate()
   end)

   scrollbarframe:SetScript("OnMouseWheel",function()
      -- i think arg1 is up or down?
      ourscrollbar = getglobal(this:GetName().."ScrollBar")
      ourscrollbar:SetValue(ourscrollbar:GetValue() - (arg1*(TMArowsthatcanfit(name)/2))) --have it scroll half the list each scroll
    
   end)
   
   TMAscrollbar:SetScript("OnShow",function()
        TMAprint("Onshow")
				    end)  		
   TMAscrollbar:SetValueStep(1)
   TMAcreatescrollbartemplate(scrollbarframe)

end

function TMAcreatescrollbartemplate(ourscrollbar)

   -------------------------------------------------------------------------------
   --- this is my attempt to go the extra step and give our scrollbar some texture
   -------------------------------------------------------------------------------
   TMAtexturetop = ourscrollbar:CreateTexture()
   --   TMAtexturetop:SetHeight(TMA_BUTTON_HEIGHT)
   TMAtexturetop:SetWidth(31)
   TMAtexturetop:SetPoint("topright",29,2)
   TMAtexturetop:SetTexture("Interface\\PaperDollInfoFrame\\UI-Character-ScrollBar")
   TMAtexturetop:SetTexCoord(0,.484375,0,1) --this cuts the texture, taking only the bottomleft part of it, which just happens to fit the top of a scroll bar --thanks to possessions mod for the exact numbers

   TMAtexturebottom = ourscrollbar:CreateTexture()
   TMAtexturebottom:SetWidth(30)
   TMAtexturebottom:SetHeight(106)
   TMAtexturebottom:SetPoint("bottomright",29,-2)
   TMAtexturebottom:SetTexture("Interface\\PaperDollInfoFrame\\UI-Character-ScrollBar")
   TMAtexturebottom:SetTexCoord(.515625,1,0,.4140625) --this cuts the texture, taking only the bottomright part of it, which just happens to fit the bottom of a scroll bar
   
   TMAtexturemiddle = ourscrollbar:CreateTexture()
   TMAtexturemiddle:SetWidth(30)
   --TMAtexturemiddle:SetHeight(ourscrollbar:GetHeight())
   TMAtexturemiddle:SetPoint("bottomright",29,0)
   TMAtexturemiddle:SetPoint("topright",29,0)
   
   TMAtexturemiddle:SetTexture("Interface\\PaperDollInfoFrame\\UI-Character-ScrollBar")
   TMAtexturemiddle:SetTexCoord(0,.5,.2,.2) --this cuts the texture, taking only the left

   TMAtexture = ourscrollbar:CreateTexture()
   TMAtexture:SetHeight(25)
   --   TMAtexture:SetWidth(30)
   TMAtexture:SetAllPoints()
   TMAtexture:SetPoint("right",29,45)
   TMAtexture:SetTexture("Interface\\PaperDollInfoFrame\\UI-Character-ScrollBar")
   TMAtexture:SetTexCoord(0,.4,.8,.8) --this cuts the texture, taking only the left middle part of it
   TMAtexture:Hide()
end
--=======================================================================


function TMACreateButton(name,i)
	local ourframe = getglobal(name.."frame")
	local ournamebutton = CreateFrame("Button",name.."button"..i,ourframe)
		ournamebutton:SetHeight(TMA_ROW_HEIGHT)
		ournamebutton:SetWidth(TMA_COLUMN_WIDTH)
		local ourcheckbutton = getglobal(name.."checkbutton"..i)
		ournamebutton:SetPoint("TOPLEFT",ourcheckbutton,"TOPRIGHT")
		ournamebutton:SetNormalFontObject(GameFontNormal)
		ournamebutton:SetHighlightTexture("Interface\\QuestFrame\\UI-QuestLogTitleHighlight")
		--ournamebutton:SetText("Button "..i)
		ournamebutton:SetScript("OnClick",function()
			local ourcheckbutton = getglobal(name.."checkbutton"..i)
			ourcheckbutton:Click()
		end)
		
	return ournamebutton
end

function TMACreateCheckButton(name,i)
	local ourframe = getglobal(name.."frame")
	local ourcheckbutton = CreateFrame("CheckButton",name.."checkbutton"..i,ourframe)
		ourcheckbutton:SetDisabledTexture("Interface\\Buttons\\UI-CheckBox-Check-Disabled") 
		ourcheckbutton:SetHighlightTexture("Interface\\Buttons\\UI-CheckBox-Highlight") 
		ourcheckbutton:SetNormalTexture("Interface\\Buttons\\UI-CheckBox-Up")
		ourcheckbutton:SetPushedTexture("Interface\\Buttons\\UI-CheckBox-Down")	
		ourcheckbutton:SetCheckedTexture("Interface\\Buttons\\UI-CheckBox-Check")	
		ourcheckbutton:SetHeight(TMA_HEIGHT_OF_BUTTON)
		ourcheckbutton:SetWidth(ourcheckbutton:GetHeight())		
		ourcheckbutton:SetNormalFontObject(GameFontNormal)
		ourcheckbutton.number = i

		-- if its the top of a row		
		if (i == 1) then
				--its the first button
				ourcheckbutton:SetPoint("TOPLEFT",10,-10)
		else
			local previousrow= getglobal(name.."checkbutton"..(i-1))
			ourcheckbutton:SetPoint("TOP",previousrow,"BOTTOM",0,TMA_GAP_BETWEEN_BUTTONS)
		end		
		
	return ourcheckbutton
end

function TMArowsthatcanfit(name)
	
	local ourframe = getglobal(name.."frame")
	local ourheight = ourframe:GetHeight()
	local ourrowheight = TMA_ROW_HEIGHT
	return math.floor(ourheight / ourrowheight) - 1

end


